package org.serviio.dlna;

import java.util.Arrays;
import java.util.List;
import org.serviio.library.metadata.MediaFileType;

public enum MediaFormatProfile {
	MP3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	 //TODO start changes
	DSD {
		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	 //TODO end changes
	MP2_MPS {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	WMA_BASE {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	WMA_FULL {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	LPCM16_44_MONO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	LPCM16_44_STEREO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	LPCM16_48_MONO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	LPCM16_48_STEREO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	AAC_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	AAC_ISO_320 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	AAC_ADTS {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	AAC_ADTS_320 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	FLAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	OGG {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.AUDIO;
		}
	},
	JPEG_SM {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	JPEG_MED {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	JPEG_LRG {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	JPEG_TN {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	PNG_LRG {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	PNG_TN {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	GIF_LRG {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	RAW {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.IMAGE;
		}
	},
	MPEG1 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_PS_PAL {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_PS_NTSC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_EU {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_EU_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_EU_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_NA {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_NA_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_NA_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_KO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_KO_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_SD_KO_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG_TS_JP_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVI {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MATROSKA {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	HLS {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}

		@Override
		public boolean isManifestFormat() {
			return true;
		}
	},
	FLV {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	DVR_MS {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	WTV {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	OGV {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	REAL_VIDEO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_MP_SD_AAC_MULT5 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_MP_SD_MPEG1_L3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_MP_SD_AC3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_MP_HD_720p_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_MP_HD_1080i_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_HP_HD_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_MP_SD_DTS {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_MP_SD_DTSHD {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_HP_HD_DTS {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_HP_HD_DTSHD {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_AAC_MULT5 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_AAC_MULT5_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_AAC_MULT5_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_MPEG1_L3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_MPEG1_L3_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_MPEG1_L3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_AC3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_AC3_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_HD_AC3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_HP_HD_MPEG1_L2_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_HP_HD_MPEG1_L2_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_AAC_MULT5 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_AAC_MULT5_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_AAC_MULT5_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_MPEG1_L3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_MPEG1_L3_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_MPEG1_L3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_HP_SD_MPEG1_L2_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_HP_SD_MPEG1_L2_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_AC3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_AC3_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_MP_SD_AC3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_HD_DTS_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_HD_DTS_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_DTSHD_MA_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_DTSHD_MA_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	WMVMED_BASE {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	WMVMED_FULL {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	WMVMED_PRO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	WMVHIGH_FULL {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	WMVHIGH_PRO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_ASF_AP_L1_WMA {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_ASF_AP_L2_WMA {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_ASF_AP_L3_WMA {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_TS_AP_L1_AC3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_TS_AP_L2_AC3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_TS_HD_DTS_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_TS_HD_DTS_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_TS_HD_DTSHD_MA_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	VC1_TS_HD_DTSHD_MA_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_MP4_ASP_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_MP4_SP_L6_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_MP4_NDSD {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_AAC_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_AAC_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_MPEG1_L3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_MPEG1_L3_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_MPEG1_L3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_MPEG2_L2 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_MPEG2_L2_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_MPEG2_L2_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_AC3 {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_AC3_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_TS_ASP_AC3_ISO {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_TS_HD_50_LPCM_T {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_MP4_LPCM {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_3GPP_SP_L0B_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_P2_3GPP_SP_L0B_AMR {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	AVC_3GPP_BL_QCIF15_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_H263_3GPP_P0_L10_AMR {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	},
	MPEG4_H263_MP4_P0_L10_AAC {

		@Override
		public MediaFileType getFileType() {
			return MediaFileType.VIDEO;
		}
	};

	private MediaFormatProfile() {
	}

	public abstract MediaFileType getFileType();

	public boolean isManifestFormat() {
		return false;
	}

	public static List<MediaFormatProfile> getSupportedMediaFormatProfiles() {
		return Arrays.asList(MediaFormatProfile.values());
	}

}
